module MidasClient
  module EndPoints

    def production?
      if !self.environment.blank?
        self.environment.upcase == 'PRODUCTION'
      else
        (ENV['RACK_ENV'].upcase == 'PRODUCTION') || ENV['PRODUCTION'] || ENV['production']
      end
    end

    # alias for set_environment
    def set_env(e)
      self.environment=e
    end

    def get_environment
      get_env
    end

    # alias for get_environment
    def get_env
      self.production? ? EndPoints::PRODUCTION : EndPoints::DEVELOPMENT
    end

    DEVELOPMENT ={
        url: 'http://api.sandbox.ansertecnologia.net',
        management_auth: 'Basic bWlkYXM6bXRmYndZQDE5Nzc='
    }

    PRODUCTION ={
        url: 'https://api.ansertecnologia.com',
        management_auth: 'Basic bWlkYXM6aWNzZFA/MTk5OQ=='
    }

    OPERATIONS = {
        context: '/midas-core/v2',
        store: '/creditcard',
        synchronous_transaction: '/transaction/creditcard',
        asynchronous_transaction: '/transaction/creditcard/dispatch',
        authorize: '/transaction/creditcard/authorize',
        confirm: '/transaction/creditcard/{transactionToken}/capture',
        cancel: '/transaction/creditcard/{transactionToken}/cancel',
        refund: '/transaction/creditcard/{transactionToken}/refund',
        query_by_transaction: '/transaction/{transactionToken}',
        callback: 'http://matricula.crossfitlendarios.com.br/callback',
        cards_by_user: '/customer/{documentType}/{documentNumber}/creditcard',
    }

    SUBSCRIPTIONS = {
        context: '/midas-core/v2',
        by_token: '/subscription/{subscriptionToken}',
        invoices: '/subscription/{subscriptionToken}/invoices',
        invoice_transactions: '/invoice/{invoiceToken}/transactions',
        create: '/subscription/creditcard',
        cancel: '/subscription/{subscriptionToken}/cancel',
        update: '/subscription/{subscriptionToken}',
        update_card: '/subscription/{subscriptionToken}/payment-method/creditcard',
        update_invoice: '/invoice/{invoiceToken}',
        callback: 'https://matricula.crossfitlendarios.com.br/callback'
    }

    QUERIES = {
        context: '/midas-query/v2',
        by_external_id: '/transactions/external-id/{externalId}',
        by_external_ids: '/transactions/external-ids',
        by_transaction_tokens: '/transactions/transaction-tokens',
        by_period: '/transactions?startDate={startDate}&endDate={endDate}&status={status}',
        subscriptions: "/subscriptions?status={status}",
        creditcards: '/creditcards',
        customers: '/customers'
    }

    MANAGEMENTS = {
        context: '/midas-managment/v2',
        create_pos: '/pointofsale',
        list_pos: '/pointofsale'
    }

  end
end